﻿@model UserLogin
@using System.Security.Claims
@{
    var role = User.FindFirst(ClaimTypes.Role)?.Value;
    var additionalRoles = ViewBag.additionalRoles;
    bool isOwner = ViewBag.isOwner;
    bool isAssistant = ViewBag.isAssistant;
    var assistantPermissions = Model?.AssistantPermissions?.Select(m => (int)m.Permission);
}
<div class="modal-dialog modal-lg" role="document">
    <div class="modal-content">
        <div class="modal-header">
            <h5 class="modal-title">@(Model?.Id>0?"Edit" :"Add") @(isAssistant?"Assistant":Roles.Adviser)</h5>
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <i aria-hidden="true" class="ki ki-close"></i>
            </button>
        </div>
        <form action="admin/adviser/saveadviser" class="form fv-plugins-bootstrap fv-plugins-framework" id="AddClient_form" method="post" data-ajax="true" data-ajax-begin="onFormBegin" data-ajax-complete="UserEmailChangeComplete">
            <div class="modal-body">
                <input type="hidden" asp-for="Guid" />
                <input type="hidden" asp-for="IsAssistant" value="@isAssistant" />
                <div class="row">
                    <div class="col-xl-4">
                        <div class="form-group">
                            <label asp-for="UserData.FirstName"></label>
                            <input asp-for="UserData.FirstName" class="form-control form-control-lg capitalize">
                            <span asp-validation-for="UserData.FirstName" class="text-danger"></span>
                        </div>
                    </div>
                    <div class="col-xl-4">
                        <div class="form-group">
                            <label asp-for="UserData.MiddleInitial"></label>
                            <input asp-for="UserData.MiddleInitial" class="form-control form-control-lg capitalize">
                        </div>
                    </div>
                    <div class="col-xl-4">
                        <div class="form-group">
                            <label asp-for="UserData.LastName"></label>
                            <input asp-for="UserData.LastName" class="form-control form-control-lg capitalize">
                            <span asp-validation-for="UserData.LastName" class="text-danger"></span>
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-xl-6">
                        <div class="form-group">
                            <label>Email Address</label>
                            <div class="input-group">
                                <input asp-for="Username" class="form-control form-control-lg @(Model?.Id > 0 ? "disabled" :"")" id="UserEmail">
                                @if (Model?.Id > 0 && !isOwner)
                                {
                                    <div class="input-group-append" id="edit-email">
                                        <button class="btn btn-warning w-45px" type="button" data-toggle="tooltip" data-original-title="Edit"><i class="icon-lg far fa-edit"></i></button>
                                    </div>
                                }
                            </div>
                            <span asp-validation-for="Username" class="text-danger"></span>
                        </div>
                    </div>
                </div>
                <div class="row d-none" id="code-div">
                    <div class="col-xl-4">
                        <div class="form-group">
                            <label>Verification Code</label>
                            <input asp-for="VerificationCode" class="form-control form-control-lg" value="">
                            <span asp-validation-for="VerificationCode" class="text-danger"></span>
                        </div>
                    </div>
                </div>
                @if (isAssistant)
                {
                    <div class="row">
                        <div class="col-xl-10">
                            <div class="form-group permission-select2-container">
                                <label asp-for="AssistantPermission"></label>
                                <select asp-for="AssistantPermission" class="form-control form-control-lg select2" asp-items="Html.GetEnumSelectList<AssistantPermissionEnum>()" data-placeholder="Select Permissions" style="width:100%"></select>
                                <span asp-validation-for="AssistantPermission" class="text-danger"></span>
                            </div>
                        </div>
                    </div>
                }
                @if (Model?.Id > 0 && !isOwner)
                {
                    <div class="form-group row">
                        <div class="col-1">
                            <span class="switch switch-icon switch-sm switch-custom">
                                <label>
                                    <input type="checkbox" asp-for="Active">
                                    <span></span>
                                </label>
                            </span>
                        </div>
                        <label class="switch-label form-check-label mt-1" asp-for="Active">
                            Active
                        </label>
                    </div>
                }
                else
                {
                    <input type="hidden" asp-for="Active">
                }
                @if (role == Roles.SuperAdmin && ViewBag.SetupKey != null)
                {
                   <div class="row">
                        <div class="col-xl-12">
                            <div class="form-group">
                                <label>Setup Key</label>
                                <div class="input-group">
                                    <input id="SetupKey" class="form-control form-control-lg" disabled value="@ViewBag.SetupKey">
                                    <div class="input-group-append" id="edit-email">
                                        <button class="btn btn-warning w-45px btn-copy" type="button" data-toggle="tooltip" data-original-title="Copy" data-target="SetupKey"><i class="icon-lg far fa-copy"></i></button>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                }
            </div>
            <div class="modal-footer">
                <button class="btn btn-primary font-weight-bold" id="btn_submit_client">
                    <i class="@(Model?.Id>0 ? "la la-save":"fab fa-telegram-plane")"></i> @(Model?.Id > 0 ? "Save" : "Send Invitation")
                </button>
            </div>
        </form>
    </div>
</div>
<script>
    var assistantPermissions = @Html.Raw(Json.Serialize(assistantPermissions));
    $("#AssistantPermission").val(assistantPermissions).trigger("change");
    var UserEmailChangeComplete = function(response) {
        var id = $(this).find(":submit").attr('id');
        var btn = KTUtil.getById(id);
        var frm_id = $(this).attr('id');
        var responseObj = JSON.parse(response.responseText);
        if (responseObj) {
            if (responseObj.success) {
                var modalId = $('.modal:visible').attr("id");
                var firmId = $("#firm_list .datatable-row-subtable-expanded .datatable-toggle-subtable").data("value");
                if (responseObj.data.oldEmail == responseObj.data.newEmail) {
                    toastr.options = toastrOptions;
                    toastr.success(responseObj.message);
                }
                else {
                    var swalOptions = successSwalOptions;
                    swalOptions.title = responseObj.message;
                    Swal.fire(swalOptions);
                    $("#edit-email").removeClass("d-none");
                    $("#code-div").removeClass("d-none");
                    $("#AdviserModal #UserEmail").addClass("disabled");
                }
                if (!responseObj.data.oldEmail || responseObj.data.oldEmail == responseObj.data.newEmail || $("#VerificationCode").val()) {
                    $(`#${modalId}`).modal('hide');
                    if (window['sub_datatable_' + firmId])
                        window['sub_datatable_' + firmId].reload();
                    if (window["datatable"] != undefined) {
                        var id = window["datatable"][0].id;
                        if ($(`#${id}:visible`).length > 0)
                            datatable.reload();
                    }
                }
            }
            else
                _showFormMessage(`${frm_id}`, "danger", responseObj.message, "fas fa-exclamation-triangle");
        }
        else
            _showFormMessage(`${frm_id}`, "danger", "Error Occur", "fas fa-exclamation-triangle")
        KTUtil.btnRelease(btn);
    }
    var setActiveInactiveText = function() {
        var status = $("#Active").is(":checked");
        var txt = status == true ? "Active" : "Inactive";
        $("[for='Active']").text(txt);
    }

    setActiveInactiveText();
    $("#Active").change(function() {
        setActiveInactiveText(status);
    });
    $("#edit-email").click(function() {
        $("#AdviserModal #UserEmail").removeClass("disabled");
        $("#code-div").addClass("d-none");
    });
</script>